<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.enterprise_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/enterprise/enterprise";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "企业类型",
              prop: "enterpriseType",
              rules: [{
                required: true,
                message: "请输入企业类型",
                trigger: "blur"
              }]
            },
            {
              label: "企业名称",
              prop: "enterpriseName",
              rules: [{
                required: true,
                message: "请输入企业名称",
                trigger: "blur"
              }]
            },
            {
              label: "统一信用代码",
              prop: "creditCode",
              rules: [{
                required: true,
                message: "请输入统一信用代码",
                trigger: "blur"
              }]
            },
            {
              label: "组织机构代码",
              prop: "organizationCode",
              rules: [{
                required: true,
                message: "请输入组织机构代码",
                trigger: "blur"
              }]
            },
            {
              label: "注册资金",
              prop: "registeredCapital",
              rules: [{
                required: true,
                message: "请输入注册资金",
                trigger: "blur"
              }]
            },
            {
              label: "注册地址",
              prop: "registeredAddress",
              rules: [{
                required: true,
                message: "请输入注册地址",
                trigger: "blur"
              }]
            },
            {
              label: "法定代表人",
              prop: "representative",
              rules: [{
                required: true,
                message: "请输入法定代表人",
                trigger: "blur"
              }]
            },
            {
              label: "成立日期",
              prop: "registeredDate",
              rules: [{
                required: true,
                message: "请输入成立日期",
                trigger: "blur"
              }]
            },
            {
              label: "办公电话",
              prop: "officeNum",
              rules: [{
                required: true,
                message: "请输入办公电话",
                trigger: "blur"
              }]
            },
            {
              label: "详细地址",
              prop: "region",
              rules: [{
                required: true,
                message: "请输入详细地址",
                trigger: "blur"
              }]
            },
            {
              label: "logo",
              prop: "logo",
              rules: [{
                required: true,
                message: "请输入logo",
                trigger: "blur"
              }]
            },
            {
              label: "企业简介",
              prop: "enterpriseIntroduce",
              rules: [{
                required: true,
                message: "请输入企业简介",
                trigger: "blur"
              }]
            },
            {
              label: "营业执照",
              prop: "businessLicense",
              rules: [{
                required: true,
                message: "请输入营业执照",
                trigger: "blur"
              }]
            },
            {
              label: "经度",
              prop: "longitude",
              rules: [{
                required: true,
                message: "请输入经度",
                trigger: "blur"
              }]
            },
            {
              label: "纬度",
              prop: "latitude",
              rules: [{
                required: true,
                message: "请输入纬度",
                trigger: "blur"
              }]
            },
            {
              label: "园区id",
              prop: "agencyId",
              rules: [{
                required: true,
                message: "请输入园区id",
                trigger: "blur"
              }]
            },
            {
              label: "区域id",
              prop: "residentialId",
              rules: [{
                required: true,
                message: "请输入区域id",
                trigger: "blur"
              }]
            },
            {
              label: "机构路径",
              prop: "orgPosition",
              rules: [{
                required: true,
                message: "请输入机构路径",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.enterprise_add, false),
          viewBtn: this.vaildData(this.permission.enterprise_view, false),
          delBtn: this.vaildData(this.permission.enterprise_delete, false),
          editBtn: this.vaildData(this.permission.enterprise_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
